/* Esta clase prueba el evaluador de expresiones.
 * Los usuarios ingresan nmeros o palabras o caracteres a un software,
 * y estos datos son almacenados en variables de tipo entero(int),
 * flotantes (float o double), char, String o bolean. No existe un dato
 * que sea expresin algebraica, es decir, si usted ingresa "4*3+5",
 * olvdese que automticamente interprete eso como un "17", para cualquier
 * lenguaje de programacin "4*3+5"  es solo un String, una sucesin de
 * caracteres y lo almacenar de esa forma.
 * La nica manera de que un lenguaje interprete esa ecuacin es que usted
 * use un "evaluador de expresiones". Este componente toma ese String, lo
 * descompone, busca los operadores, operandos, funciones trigonomtricas,
 * etc.. y finalmente le entrega el resultado.*/
 
import java.util.*;

class Prueba
{
	public static void main(String sbParametros[])
    {
		EvalExpr2 objExpresion = new EvalExpr2();
		
		//Ejemplo 1
		String sbEcuacion = "4*3+5";
		double fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " =" + fValor);
				
		//Ejemplo 2
		sbEcuacion = "10*2.67+13.4-6^2";
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " =" + fValor);

		//Ejemplo 3
		sbEcuacion = "sen(45)+cos(50)-tan(45)";
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " =" + fValor);

		//Ejemplo 4
		sbEcuacion = "abs(-3)+abs(-7)+sqr(16)-rcb(27)";
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " =" + fValor);

		//Ejemplo 5
		sbEcuacion = "X+5";
		objExpresion.fVariable['x'-'a']=7; //Valor de X
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " con X= " + objExpresion.fVariable['x'-'a'] + " es igual a " + fValor);
		
		//Ejemplo 6
		sbEcuacion = "3*X-2*X+6^2/2+X%6";
		objExpresion.fVariable['x'-'a']=20; //Valor de X
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " con X= " + objExpresion.fVariable['x'-'a'] + " es igual a " + fValor);

		//Ejemplo 7
		sbEcuacion = "sen(X)-2*X+cos(X)-abs(X)";
		objExpresion.fVariable['x'-'a']=-5; //Valor de X
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " con X= " + objExpresion.fVariable['x'-'a'] + " es igual a " + fValor);

		//Ejemplo 8
		sbEcuacion = "X+Y-Z*X+3-Z*2";
		objExpresion.fVariable['x'-'a']=1; //Valor de X
		objExpresion.fVariable['y'-'a']=2; //Valor de Y
		objExpresion.fVariable['z'-'a']=3; //Valor de Z
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		System.out.println("Ecuacion: " + sbEcuacion + " con X= " + objExpresion.fVariable['x'-'a'] + " con Y= " + objExpresion.fVariable['y'-'a'] + " con Z= " + objExpresion.fVariable['z'-'a'] +" es igual a " + fValor);
			
		//Ejemplo 9
		sbEcuacion = "2+";
		int iError = objExpresion.iChequeaSintaxis(sbEcuacion);
		if (iError != 0 )
			System.out.println("Ecuacion: " + sbEcuacion + " tiene error de sintaxis: " + iError);
		
		//Ejemplo 10
		sbEcuacion = "(5+3+2*(5-1)";
		iError = objExpresion.iChequeaSintaxis(sbEcuacion);
		if (iError != 0 )
			System.out.println("Ecuacion: " + sbEcuacion + " tiene error de sintaxis: " + iError);

		//Ejemplo 11
		sbEcuacion = "6--2";
		iError = objExpresion.iChequeaSintaxis(sbEcuacion);
		if (iError != 0 )
			System.out.println("Ecuacion: " + sbEcuacion + " tiene error de sintaxis: " + iError);

		//Ejemplo 12
		sbEcuacion = "dap(65)-sin(12)";
		iError = objExpresion.iChequeaSintaxis(sbEcuacion);
		if (iError != 0 )
			System.out.println("Ecuacion: " + sbEcuacion + " tiene error de sintaxis: " + iError);

		//Ejemplo 12
		sbEcuacion = "4-sin(x)*cos(y)+tan(z)";
		iError = objExpresion.iChequeaSintaxis(sbEcuacion);
		if (iError != 0 )
			System.out.println("Ecuacion: " + sbEcuacion + " tiene error de sintaxis: " + iError);
		else
			System.out.println("Ecuacion: " + sbEcuacion + " NO TIENE ERRORES SINTACTICOS");
			

        //Ejemplo 13
        sbEcuacion = "X/3-1/X+6*X+X^2/7";
		System.out.println("Ecuacion: " + sbEcuacion + " sera evaluada desde 1 hasta 50 muy rapidamente");
		
		fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
		for (int iValorX=1; iValorX<=50; iValorX++)
		{ 
			objExpresion.fVariable['x'-'a']=iValorX; //Valor de X
			fValor = objExpresion.fRapidoEvalua();
			System.out.print(fValor + ", ");
		}
	}
}
