/* Evaluador de Expresiones escrito en Java
   
 Propiedad Intelectual
 Nombre:	Rafael Alberto Moreno Parra
 
 Programa:	Evaluador de expresiones en Java

 Fecha:		23 de Junio de 2005

 Explicacion:

   Sus caracteristicas principales son:
   - Evaluador NO recursivo.
   - Optimizado para ciclos.
   - Evalua funciones trigonometricas en radianes.
   - Ilimitado tamao de la expresin simple (sin parntesis)
   - Hasta 100 parntesis
   - Hasta 23 variables

   Forma de uso:

	 Ej:

		 public static void main(String sbParametros[])
		 {
		 	EvalExpr2 objExpresion = new EvalExpr2();
		
			String sbEcuacion = "sin(x)+cos(y)-tan(z)";
			
			//Validar la sintaxis es
			int iError = objExpresion.iChequeaSintaxis(sbEcuacion);
			if (iError != 0 )
				System.out.println("Error de sintaxis: " + iError);
				
			//Evalua la expresion
			if (iError == 0)
			{
				objExpresion.fVariable['x'-'a']=7; //Valor de X
				objExpresion.fVariable['y'-'a']=8; //Valor de Y
				objExpresion.fVariable['z'-'a']=2; //Valor de Z
				
				float fValor = objExpresion.fEvaluaEcuacion(sbEcuacion);
				System.out.println(fValor);
		
				//Evalua la expresion a alta velocidad DESPUES de usar fEvaluaEcuacion
				for (int iCont=1; iCont<=500; iCont++)
				{
					objExpresion.fVariable['x'-'a'] = iCont;
					fValor = objExpresion.fRapidoEvalua();
					System.out.println(fValor);
				}
				
			}
		}


Algoritmo:

   Por ejemplo, si tuviesemos una expresion algebraica as:
	13-4*sin(3+x)+8-(12+x*y)

   la expresin se desintegra en nodos (siempre de derecha a izquierda)

   Nodo0 = "12+x*y"             => 13-4*sin(3+x)+8-Nodo0;
   Nodo1 = "3+x"                => 13-4*sinNodo1+8-Nodo0;
   Nodo2 = "sinNodo1"           => 13-4*Nodo2+8-Nodo0;
   Nodo3 = "13-4*Nodo2+8-Nodo0"

   cada Nodo es evaluado como una expresion simple (se desintegra en operandos y operadores)
   Nodo0 ="12+x*y"
   => Nodo0a= 12 +
	  Nodo0b=  x *
	  Nodo0c=  y N
	  
Estandares:
 En el codigo, se uso el estandar Hungaro para nombrar variables y estandares aceptados Java
 Prefijo		Para
	i			integer
	d			float
	f			float
	sb			String
	c			char
*/
public class EvalExpr2
{
	/* 0 esta todo bien
	 * 1 es mala exponenciacin
	 * 2 es divisin por cero
	 * 3 es error en funcion
	 */
	public int ERRORMATEMATICO;
	
	/* Almacena el valor de las variables. Mximo 26 variables. */
	public float fVariable[] = new float[26];
	
	/* Almacena el valor de los acumulados. Mximo 500 parntesis. */
	public float fAcumular[] = new float[501];
	
	/* Variable que lleva la lista de expresiones */
	int iNumAcums;
	NodoBus objBus; //Pasea por la lista de acums
	NodoBus objTopeLista; //Mantiene viva la lista de acums
	boolean bPrimeraExpresion; //Se usa cuando se crea la cabeza la lista de expresiones
	
	/* Variable que lleva la lista de una expresin sola sin parentesis pero que se mantiene */
	NodoExprCompleja objComple;
	
	/* Variable que lleva la lista de una expresin sola sin parentesis pero que se destruye */
	NodoExprSimple objNodo;
	
	/* Las funciones */
	String sbFuncion[] = new String[20];
	
	/* El constructor */
	public EvalExpr2 ()
    {
    	//Las funciones sern siempre tres letras
    	sbFuncion[1]="sin"; //seno
		sbFuncion[2]="sen"; //seno
		sbFuncion[3]="cos"; //coseno
		sbFuncion[4]="tan"; //tangente
		sbFuncion[5]="abs"; //valor absoluto
		sbFuncion[6]="asn"; //arcoseno
		sbFuncion[7]="acs"; //arcocoseno
		sbFuncion[8]="atn"; //arcotangente
		sbFuncion[9]="log"; //logaritmo
		sbFuncion[10]="int"; //valor entero redondeado
		sbFuncion[11]="exp"; //exponencial
		sbFuncion[12]="sqr"; //Raiz Cuadrada
		sbFuncion[13]="rcb"; //Raiz Cubica
    }

	//Por compatibilidad hacia atrs...
	public float fCapturaEcuacion(String sbEcuacion, float fX, float fY)
	{
		fVariable['x'-'a']=fX;
		fVariable['y'-'a']=fY;
			
		return fEvaluaEcuacion(sbEcuacion);
	}
	
	//Por compatibilidad hacia atrs...
	public float fCicloEvalua(float fX, float fY)
	{
		fVariable['x'-'a']=fX;
		fVariable['y'-'a']=fY;
		
		return fRapidoEvalua();
	}

	
	public float fEvaluaEcuacion(String sbEcuacion)
	{
		int iCont, iTamano, iChar;
		String sbEcuacion2="";
		char cLetra;

		//La vuelve a minusculas
		sbEcuacion = sbEcuacion.toLowerCase();
		
		//Elimina los espacios
		iTamano = sbEcuacion.length();
		for(iCont=0; iCont < iTamano; iCont++)
		{
			cLetra = sbEcuacion.charAt(iCont);
			if( cLetra != ' ')
				sbEcuacion2 += cLetra;
		}
		sbEcuacion = "(" + sbEcuacion2 + ")";
		
		// Desintegra la expresion en Acums
		bPrimeraExpresion = true;
		vOptimizador(sbEcuacion);

		//Manda a evaluar
		return fRapidoEvalua();
	}	

	// Convierte la expresion en Acums
	private void vOptimizador(String sbEcuacion)
	{
		int iCont, iCont2=0, iFuncion;
		iNumAcums = 0;
		char cFuncA, cFuncB, cFuncC, cLetra;
		
		do
		{
			// Busca parentesis '(' de derecha a izquierda
			for (iCont=sbEcuacion.length()-1; iCont>=0; iCont--)
			{
				cLetra = sbEcuacion.charAt(iCont);
				if (cLetra == ')' ) iCont2=iCont;
				if (cLetra == '(' ) break;
			}
			
			//Busca la pareja del '(', es decir: ')'
			if(iCont>=0)
			{
				//Extraigo la subcadena entre parentesis y lo coloco en los acums...
				//y de una vez la desintegro
				vNuevoAcumulado(sbEcuacion.substring(iCont+1, iCont2));
				
				// Cambio la ecuacion por la nueva expresion basada en acums
				sbEcuacion = sbEcuacion.substring(0, iCont) + (char) (iNumAcums+123) + sbEcuacion.substring(iCont2+1);
				iNumAcums++;
				
				//Chequeo si las tres letras anteriores corresponden a una funcion
				if (iCont >= 3)
				{
					cFuncA = sbEcuacion.charAt(iCont-3);
					cFuncB = sbEcuacion.charAt(iCont-2);
					cFuncC = sbEcuacion.charAt(iCont-1);
					for (iFuncion=1; iFuncion<=13; iFuncion++)
					{
						if (cFuncA == sbFuncion[iFuncion].charAt(0) && 
						    cFuncB == sbFuncion[iFuncion].charAt(1) &&
						    cFuncC == sbFuncion[iFuncion].charAt(2))
						{
							sbEcuacion = sbEcuacion.substring(0, iCont-3) + (char) (iNumAcums+123) + sbEcuacion.substring(iCont+1);
							objBus = new NodoBus(objBus);
							objBus.iCodigo=iNumAcums;
							objBus.cFuncion=(char)iFuncion;
							iNumAcums++;
						}
					}
				}
			}
		} while (iCont > 0);
	}
	
	//Genera una lista simplemente enlazada con todos los acums
	private void vNuevoAcumulado(String sbExpresion)
	{
		//Convierte algo como -5+3*x en 0-5+3*x
		if (sbExpresion.charAt(0)=='-') sbExpresion = "0" + sbExpresion;
		sbExpresion += 'N'; //Finaliza siempre en operador N
		
		//Crea un nuevo acumulado
		if (bPrimeraExpresion)
		{
			objBus = new NodoBus();
			objTopeLista = objBus;
			bPrimeraExpresion = false;
		}
		else
			objBus = new NodoBus(objBus);	
		
		String sbNumero = ""; //Variable que lleva el acumulado de los numeros
		float fNumero; //Valor del numero de String a float
		int iChar; //Pasea por la expresin
		char cTipo='0'; //Tipo de dato: Numero+Operador Variable+Operador Acumulado+Operador
		int iAcumular=0; //Acumulado
		char cCaracter, cVariable='a';
	
		//Crea la subexpresin dentro de la lista NodoBus
		objBus.iCodigo = iNumAcums;
		objBus.cFuncion = 0; //No es una funcion;
		for(iChar=0; iChar < sbExpresion.length(); iChar++)
		{
			cCaracter=sbExpresion.charAt(iChar);
			
			//Si son numeros entonces
			if ( (cCaracter >= '0' && cCaracter <= '9' ) || cCaracter=='.')
			{
				cTipo = '0';
				sbNumero = sbNumero + cCaracter;
			}

			//Si son variables entonces
			if (cCaracter >= 'a' && cCaracter <= 'z')
			{
				cTipo = '1';
				cVariable = cCaracter;
			}
			
			//Si son acumulados entonces
			if (cCaracter >= 123)
			{
				cTipo = '2';
				iAcumular = (int) cCaracter - 123;
			}
			
			//Si son operadores
			if (cCaracter == '*' || cCaracter == '/' || cCaracter == '-' || cCaracter == '^' || cCaracter == '%' || cCaracter == '+' || cCaracter == 'N')
			{
				//Tipo 1. Numero y operador
				switch(cTipo)
				{
					case '0':	fNumero = Float.valueOf(sbNumero);
								objBus.vAdiciona('0', fNumero, '0', 0, cCaracter);
								sbNumero="";
								break;
					case '1':   objBus.vAdiciona('1', 0, cVariable, 0, cCaracter);
								break;
					case '2':   objBus.vAdiciona('2', 0, '0', iAcumular, cCaracter);
								break;
				}
			}
		} // Fin for
	}
	
	
	/* Esta rutina evalua rpidamente la expresin porque ya esta pre-analizada */
	public float fRapidoEvalua()
	{
		float fValor, fAcumulado;
		
		//Empieza sin error matematico
		ERRORMATEMATICO = 0;
		
		//Crea variable para recorrer la lista
		NodoBus objTemp = objTopeLista;

		/* Tiene que armarse asi la expresion compleja y sale mas rpido
		 * De: 30 + 20 - 10
		 * A:  [10 N] -> [20 -] -> [30 +] -> null
		 *
		 * */
		NodoExprCompleja objComple;

		while(true)
		{
			//Para una funcion hace otra cosa
			if (objTemp.cFuncion > 0)
			{
				switch(objTemp.cFuncion)
				{
					case 1:
					case 2: //Seno
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.sin(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 3: //Coseno
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.cos(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 4: //Tangente
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.tan(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 5: //valor absoluto
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.abs(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 6: //arcoseno
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.asin(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 7: //arcocoseno
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.acos(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 8: //Arcotangente
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.atan(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 9: //Logaritmo
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.log(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}					
					case 10: //Valor entero redondeado
						try
						{
							fAcumular[objTemp.iCodigo] = (int) (fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 11: //Exponencial
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.exp(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 12: //Raiz Cuadrada
						if (fAcumular[objTemp.iCodigo-1] < 0)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
						
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.sqrt(fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
					case 13: //Raiz Cubica
						try
						{
							fAcumular[objTemp.iCodigo] = (float) Math.cbrt((double)fAcumular[objTemp.iCodigo-1]);
							break;
						}
						catch(ArithmeticException a)
						{
							fAcumular[objTemp.iCodigo] = 0;
							ERRORMATEMATICO = 3;
							return 0;
						}
				}
			}
			else
			{
				//Para traer la subexpresion
				objComple = objTemp.objComplejo;
				objNodo = null;
			
   				/* Copia la expresin compleja a la expresin simple pero ya dando
    	 	 	* los valores que son y queda de este modo:
    	 	 	*
    	 	 	* [30 +] -> [20 -] -> [10 N] -> null
    	 	 	*
    	 		**/
				while (true)
    			{
    				switch(objComple.cTipo)
    				{
    					case '0': /* Solo es el valor y el operador */
    							objNodo = new NodoExprSimple(objComple.fNumero, objComple.cOperador, objNodo);
    							break;
	    				case '1': /* Es la variable y el operador */
    							fValor = fVariable[objComple.cVariable-97];
    							objNodo = new NodoExprSimple(fValor, objComple.cOperador, objNodo);
    							break;
    					case '2': /* Es un acumulado y el operador */
    							fAcumulado = fAcumular[objComple.iAcumulador];
	    						objNodo = new NodoExprSimple(fAcumulado, objComple.cOperador, objNodo);
    							break;
    				}
    				objComple = objComple.Flecha;
    				if (objComple==null) break;
    			} 
    		
    			//Evalua la expresin simple
    			fAcumular[objTemp.iCodigo] = fExpresionSimple();
    		}
				
    		
    		//Siguiente expresion
    		objTemp = objTemp.FlechaD;
    		if (objTemp == null) break;
		}
		
		//Devuelve el valor de la expresin
		if (ERRORMATEMATICO != 0)
			return 0;
		else
			return fAcumular[iNumAcums-1];
	}


    private float fExpresionSimple()
    {
    	float fValor, fAcumulado;

		//Guarda la primera posicin
		NodoExprSimple Cabecera = objNodo;

		// ####################### Exponenciacin  #######################
		NodoExprSimple Temporal;
		while(true)
		{
			if (objNodo.cOperador == '^')
			{
				Temporal = objNodo.Flecha;
				if (objNodo.fNumero < 0 && (Temporal.fNumero - (int) Temporal.fNumero) != 0 )
				{
					objNodo.fNumero = 0;
					ERRORMATEMATICO = 1;	
				}		
				else
				    objNodo.fNumero = (float) Math.pow(objNodo.fNumero, Temporal.fNumero);
				objNodo.cOperador = Temporal.cOperador;
				objNodo.Flecha = Temporal.Flecha;
			}
			else
		        objNodo = objNodo.Flecha;
			if (objNodo==null) break;
		}
		objNodo = Cabecera; //Restaura primera posicion

		// ####################### Hace la modulacin, divisin y multiplicacin #######################
		while(true)
		{
			switch(objNodo.cOperador)
			{
				case '%':
					Temporal = objNodo.Flecha;
					if (Temporal.fNumero == 0)
					{
						ERRORMATEMATICO = 2;
						objNodo.fNumero = 0;
					}
					else
					    objNodo.fNumero = objNodo.fNumero % Temporal.fNumero;
					objNodo.cOperador = Temporal.cOperador;
					objNodo.Flecha = Temporal.Flecha;
					break;
				case '/':
					Temporal = objNodo.Flecha;
					if (Temporal.fNumero == 0)
					{
						ERRORMATEMATICO = 2;
						objNodo.fNumero = 0;
					}
					else
						objNodo.fNumero = objNodo.fNumero / Temporal.fNumero;
					objNodo.cOperador = Temporal.cOperador;
					objNodo.Flecha = Temporal.Flecha;
					break;
				case '*':
					Temporal = objNodo.Flecha;
					objNodo.fNumero = objNodo.fNumero * Temporal.fNumero;
					objNodo.cOperador = Temporal.cOperador;
					objNodo.Flecha = Temporal.Flecha;
					break;
				default: objNodo = objNodo.Flecha;
			}
			if (objNodo==null) break;
		}
		
		//Restaura primera posicion
		objNodo = Cabecera;

		// ####################### Hace la suma y resta #######################
		float fTotal = objNodo.fNumero;
		char cOperador = objNodo.cOperador;
		while (cOperador!='N')
		{
    		objNodo = objNodo.Flecha;
    		if (cOperador == '+')
 				fTotal += objNodo.fNumero;
    		else
 				fTotal -= objNodo.fNumero;
 			cOperador = objNodo.cOperador;
		}

		// ######################### Imprime nuevamente ##########################
		return fTotal;
    }
    
    
   	/* Validar la sintaxis de la expresin algebraica
	RETORNA:
	1:  Dobles operandos. Ej: 5*+3
	2:  Parentesis desbalanceados  Ej: 4-(3*4
	3:  Numero seguido de (      Ej: 7-4(3*2)
	4:  Operando(+,-,*,/,^) seguido de )   Ej: 3-(4*)+2
	5:  Parentesis ) seguido de numero Ej: (12-3)8
	6:  Funcion inexistente Ej: Flow
	7:  Simbolo raro Ej: @%&
	8:  Parentesis Vacio Ej: 4+()-3
	9:  Parentesis Mal Ej:  5+3)-(2*5
	*/
	public int iChequeaSintaxis(String sbEcuacion)
	{
		int CORRECTO = 0;
		int DOBLESOPERANDOS = 1;
		int PARENTESISMALBALANCE = 2;
		int NUMEROPARENTESISABRE = 3;
		int OPERANDOPARENTESISCIERRA = 4;
		int PARENTCIERRANUMERO = 5;
		int MALFUNCION = 6;
		int SIMBOLORARO = 7;
		int PARENTESISVACIO = 8;
		int PARENTESISMAL = 9;
	
		char cCar1, cCar2, cCar3;
		String sbEcuacion2 = "";
		int iCont;

		//Convierte la cadena en minsculas
		sbEcuacion = sbEcuacion.toLowerCase();

		//Elimina los espacios
		for(iCont=0; iCont < sbEcuacion.length(); iCont++)
		{
			char cLetra = sbEcuacion.charAt(iCont);
			if( cLetra != ' ')
				sbEcuacion2 += cLetra;
		}
		sbEcuacion = sbEcuacion2;
		
		//Chequea que no hayan operadores seguidos
		for(iCont=0; iCont < sbEcuacion.length()-1; iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			cCar2 = sbEcuacion.charAt(iCont+1);

			// Valida dobles operandos
			if( cCar1=='^' || cCar1=='-' || cCar1=='*' || cCar1=='+' || cCar1=='%')
				if( cCar2=='^' || cCar2=='-' || cCar2== '*' || cCar2=='+' || cCar2=='%')
					return DOBLESOPERANDOS;

			// Valida numero seguido de (
			if( cCar1>='0' && cCar1<='9' && cCar2=='(')
				return NUMEROPARENTESISABRE;

			if( cCar2>='0' && cCar2<='9' && cCar1==')')
				return PARENTCIERRANUMERO;

			// Valida operador seguido de )
			if( cCar1=='+' || cCar1=='-' || cCar1=='*' || cCar1=='/' || cCar1=='^' || cCar1=='%')
				if( cCar2==')')
					return OPERANDOPARENTESISCIERRA;
		}

		// Valida parentesis desbalanceados
		int iParent =0;
		for(iCont=0; iCont < sbEcuacion.length(); iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			if( cCar1=='(' ) iParent++;
			if( cCar1==')' ) iParent--;
		}
		if(iParent!=0) return PARENTESISMALBALANCE;

		// Valida parentesis vacios
		for(iCont=0; iCont < sbEcuacion.length()-1; iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			cCar2 = sbEcuacion.charAt(iCont+1);
			if( cCar1=='(' && cCar2==')' ) return PARENTESISVACIO;
		}

		// Valida parentesis malos
		int iBien = 0;
		for(iCont=0; iCont < sbEcuacion.length(); iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			if (cCar1 == ')') iBien--;
			if (cCar1 == '(') iBien++;
			if( iBien < 0 ) return PARENTESISMAL;
		}


		//Debe chequearse el uso de funciones como seno, coseno, tangente...
		for(iCont=0; iCont<sbEcuacion.length(); iCont++)
		{
			if ( sbEcuacion.charAt(iCont) == '(' )
				for (int iCont2=1; iCont2<=13; iCont2++)
				{
					if ( iCont - 3 >= 0 )
					{
						String sbTempor = sbEcuacion.substring(iCont - 3, iCont );
						if	( sbFuncion[iCont2].compareTo(sbTempor) == 0)
						{
							sbEcuacion = sbEcuacion.substring(0, iCont - 3 ) + "x+" + sbEcuacion.substring(iCont);
							iCont=0;
							break;
						}
					}
				}
		}

		/* Detecta si hay funciones no reconocidas
		 * Ejemplo: 4+x-y*h+z/(r+e)*a
		 * la convierte a: 4+x-x*x+x/(x+x)*x
		 * luego chequea si hay dos 'x' continuas, si no todo esta bien  
		 *
		 * Ejemplo: 3+flow(2-x+r*t)/s-d+h-t/g
		 * la convierte a: 3+xxxx(2-x+x*x)/x-x+x-x/x
		 * Como hay cuatro 'x' seguidas es un error
		*/
		String sbNuevaEcuacion="";
		for(iCont=0; iCont<sbEcuacion.length(); iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			if( cCar1>='a' && cCar1<='z' )
				sbNuevaEcuacion = sbNuevaEcuacion + 'x';
			else
				sbNuevaEcuacion = sbNuevaEcuacion + cCar1;
		}
		sbEcuacion = sbNuevaEcuacion;	
		
		for(iCont=0; iCont < sbEcuacion.length()-1; iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			cCar2 = sbEcuacion.charAt(iCont+1);

			if( cCar1=='x' && cCar2=='x')
					return MALFUNCION;
		}
		
		//Busca simbolos raros, coge los *, +, -, /, (, ), 0 a 9, y los convierte a x
		sbNuevaEcuacion = "";
		for(iCont=0; iCont < sbEcuacion.length(); iCont++)
		{
			cCar1 = sbEcuacion.charAt(iCont);
			if (cCar1=='+' || cCar1=='-' || cCar1=='*' || cCar1=='/' || cCar1=='^' || cCar1=='%' || cCar1=='(' || cCar1==')' || cCar1=='.')
				sbNuevaEcuacion = sbNuevaEcuacion + 'x';
			else if (cCar1 >= '0' && cCar1 <= '9')
				sbNuevaEcuacion = sbNuevaEcuacion + 'x';
			else
				sbNuevaEcuacion = sbNuevaEcuacion + cCar1;
		}
		for(iCont=0; iCont < sbNuevaEcuacion.length(); iCont++)
			if (sbNuevaEcuacion.charAt(iCont) != 'x')
				return SIMBOLORARO;

		// La expresin algebraica est bien
		return CORRECTO;

	} //Fin del metodo ChequeaSintaxis

}